diff --git a/gcc/m2/gm2-compiler/P0SyntaxCheck.bnf b/gcc/m2/gm2-compiler/P0SyntaxCheck.bnf
index 07f861adac9..868484c9b62 100644
--- a/gcc/m2/gm2-compiler/P0SyntaxCheck.bnf
+++ b/gcc/m2/gm2-compiler/P0SyntaxCheck.bnf
@@ -47,9 +47,14 @@ IMPLEMENTATION MODULE P0SyntaxCheck ;
 FROM M2LexBuf IMPORT currentstring, currenttoken, GetToken, InsertToken,
                      InsertTokenAndRewind, GetTokenNo, DisplayToken, DumpTokens ;
 
+FROM M2Quads IMPORT PushT, PushTF, IsAutoPushOn, PushAutoOff, PushAutoOn,
+                    PopAuto, DisplayStack, PushTFtok, PushTtok, DupFrame,
+                    Top ;
+
+FROM M2Reserved IMPORT tokToTok, toktype, NulTok, ImportTok, ExportTok,
+                       QualifiedTok, UnQualifiedTok, BuiltinTok, InlineTok ;
+
 FROM M2MetaError IMPORT MetaErrorStringT0 ;
-FROM M2Quads IMPORT PushT, PushTF, IsAutoPushOn, PushAutoOff, PushAutoOn, PopAuto, DisplayStack, PushTFtok, PushTtok ;
-FROM M2Reserved IMPORT tokToTok, toktype, NulTok, ImportTok, ExportTok, QualifiedTok, UnQualifiedTok, BuiltinTok, InlineTok ;
 FROM P2SymBuild IMPORT BuildString, BuildNumber ;
 FROM NameKey IMPORT Name, NulName, makekey ;
 FROM StrLib IMPORT StrCopy, StrConCat, StrEqual ;
@@ -64,7 +69,7 @@ FROM P0SymBuild IMPORT RegisterImports, RegisterInnerImports,
                        RegisterProgramModule,
                        RegisterImplementationModule, RegisterDefinitionModule,
                        RegisterInnerModule, EndModule,
-                       RegisterProcedure, EndProcedure ;
+                       RegisterProcedure, EndProcedure, EndForward ;
 
 FROM SymbolTable IMPORT NulSym, PutModuleContainsBuiltin, PutHiddenTypeDeclared ;
 
@@ -88,6 +93,16 @@ VAR
    InsertCount      : CARDINAL ;
 
 
+(*
+   BlockAssert - wrap an Assert specifically for blocks.
+*)
+
+PROCEDURE BlockAssert (value: BOOLEAN) ;
+BEGIN
+   Assert (value) ;
+END BlockAssert ;
+
+
 PROCEDURE ErrorString (s: String) ;
 BEGIN
    MetaErrorStringT0 (GetTokenNo (), s) ;
@@ -487,6 +502,7 @@ token   'EXIT'            exittok
 token   'EXPORT'          exporttok
 token   'FINALLY'         finallytok
 token   'FOR'             fortok
+token   'FORWARD'         forwardtok
 token   'FROM'            fromtok
 token   'IF'              iftok
 token   'IMPLEMENTATION'  implementationtok
@@ -805,11 +821,20 @@ LoopStatement := "LOOP" StatementSequence "END" =:
 
 WithStatement := "WITH" Designator "DO" StatementSequence "END" =:
 
-ProcedureDeclaration :=
-                        ProcedureHeading ";" ( ProcedureBlock             % PushAutoOn %
-                                                              Ident       % EndProcedure %
+ProcedureDeclaration :=                                                   % VAR top: CARDINAL ; %
+                                                                          % top := Top () %
+                        ProcedureHeading ";" PostProcedureHeading         % BlockAssert (top = Top ()) %
+                                                                  =:
+
+PostProcedureHeading := ProperProcedure | ForwardDeclaration =:
+
+ForwardDeclaration := "FORWARD"                                           % EndForward %
+                    =:
+
+ProperProcedure := ProcedureBlock                                         % PushAutoOn %
+                                  Ident                                   % EndProcedure %
                                                                           % PopAuto %
-                                                                    ) =:
+                                         =:
 
 DefineBuiltinProcedure := [ "__ATTRIBUTE__" "__BUILTIN__" "(" "(" Ident ")" ")" |
                             "__INLINE__" ] =:
diff --git a/gcc/m2/gm2-compiler/P1Build.bnf b/gcc/m2/gm2-compiler/P1Build.bnf
index a3534fcb84d..ac96ddb383f 100644
--- a/gcc/m2/gm2-compiler/P1Build.bnf
+++ b/gcc/m2/gm2-compiler/P1Build.bnf
@@ -46,7 +46,7 @@ IMPLEMENTATION MODULE P1Build ;
 
 FROM M2LexBuf IMPORT currentstring, currenttoken, GetToken, InsertToken, InsertTokenAndRewind, GetTokenNo ;
 FROM M2Error IMPORT ErrorStringAt ;
-FROM M2Quads IMPORT PushT, PushTF, PushTFtok, IsAutoPushOn, PushAutoOff, PushAutoOn, PopAuto, DisplayStack ;
+FROM M2Quads IMPORT Top, PushT, PushTF, PushTFtok, IsAutoPushOn, PushAutoOff, PushAutoOn, PopAuto, DisplayStack, DupFrame ;
 FROM M2Reserved IMPORT tokToTok, toktype, NulTok, ImportTok, ExportTok, QualifiedTok, UnQualifiedTok, BuiltinTok, InlineTok ;
 FROM NameKey IMPORT Name, NulName, makekey ;
 FROM StrLib IMPORT StrCopy, StrConCat, StrEqual ;
@@ -89,6 +89,7 @@ FROM P1SymBuild IMPORT P1StartBuildProgramModule,
                        BuildProcedureHeading,
                        StartBuildProcedure,
                        EndBuildProcedure,
+                       EndBuildForward,
                        AddImportToImportStatement,
                        BuildImportStatement ;
 
@@ -482,6 +483,7 @@ token   'EXIT'            exittok
 token   'EXPORT'          exporttok
 token   'FINALLY'         finallytok
 token   'FOR'             fortok
+token   'FORWARD'         forwardtok
 token   'FROM'            fromtok
 token   'IF'              iftok
 token   'IMPLEMENTATION'  implementationtok
@@ -869,10 +871,20 @@ LoopStatement := "LOOP" StatementSequence "END" =:
 
 WithStatement := "WITH" Designator "DO" StatementSequence "END" =:
 
-ProcedureDeclaration := ProcedureHeading ";" ( ProcedureBlock              % PushAutoOn %
-                        Ident )                                            % EndBuildProcedure %
+ProcedureDeclaration :=                                                    % VAR top: CARDINAL ; %
+                                                                           % top := Top () %
+                        ProcedureHeading ";" PostProcedureHeading          % Assert (top = Top ()) %
+                                                                  =:
+
+PostProcedureHeading := ProperProcedure | ForwardDeclaration =:
+
+ForwardDeclaration := "FORWARD"                                            % EndBuildForward %
+                    =:
+
+ProperProcedure := ProcedureBlock                                          % PushAutoOn %
+                                  Ident                                    % EndBuildProcedure %
                                                                            % PopAuto %
-                      =:
+                                        =:
 
 DefineBuiltinProcedure := "__ATTRIBUTE__" "__BUILTIN__" "(" "(" Ident ")" ")"
                           | "__INLINE__"                                   % PushT(InlineTok) %
diff --git a/gcc/m2/gm2-compiler/P1SymBuild.def b/gcc/m2/gm2-compiler/P1SymBuild.def
index c909d7e2387..89ed3ad480b 100644
--- a/gcc/m2/gm2-compiler/P1SymBuild.def
+++ b/gcc/m2/gm2-compiler/P1SymBuild.def
@@ -25,37 +25,12 @@ DEFINITION MODULE P1SymBuild ;
    Title      : P1SymBuild
    Author     : Gaius Mulley
    Date       : 24/6/87
-   LastEdit   : Sat Dec  9 11:34:34 EST 1989
    System     : UNIX (GNU Modula-2)
    Description: Builds symbol entities, types, constants, variables,
                 procedures, modules and scopes.
                 All procedures are only called during Pass 1.
 *)
 
-EXPORT QUALIFIED P1StartBuildDefinitionModule,
-                 P1EndBuildDefinitionModule,
-                 P1StartBuildImplementationModule,
-                 P1EndBuildImplementationModule,
-                 P1StartBuildProgramModule,
-                 P1EndBuildProgramModule,
-                 StartBuildInnerModule,
-                 EndBuildInnerModule,
-                 BuildImportOuterModule,
-                 BuildExportOuterModule,
-                 BuildImportInnerModule,
-                 BuildExportInnerModule,
-                 StartBuildEnumeration,
-                 EndBuildEnumeration,
-                 BuildHiddenType,
-                 StartBuildProcedure,
-                 EndBuildProcedure,
-                 BuildProcedureHeading,
-                 BuildNulName,
-                 BuildTypeEnd,
-                 CheckExplicitExported,
-                 BuildImportStatement,
-                 AddImportToImportStatement ;
-
 
 (*
    StartBuildDefinitionModule - Creates a definition module and starts
@@ -496,6 +471,27 @@ PROCEDURE EndBuildProcedure ;
 PROCEDURE BuildProcedureHeading ;
 
 
+(*
+   EndBuildForward - Ends building a forward procedure declaration.
+
+                     The Stack:
+
+                     (This procedure is not defined in definition module)
+
+                     Entry                 Exit
+
+              Ptr ->
+                     +------------+
+                     | ProcSym    |
+                     |------------|
+                     | NameStart  |
+                     |------------|
+                                           Empty
+*)
+
+PROCEDURE EndBuildForward ;
+
+
 (*
    BuildNulName - Pushes a NulKey onto the top of the stack.
                   The Stack:
diff --git a/gcc/m2/gm2-compiler/P1SymBuild.mod b/gcc/m2/gm2-compiler/P1SymBuild.mod
index 53aab819009..40a83b7bacb 100644
--- a/gcc/m2/gm2-compiler/P1SymBuild.mod
+++ b/gcc/m2/gm2-compiler/P1SymBuild.mod
@@ -82,6 +82,9 @@ FROM SymbolTable IMPORT NulSym,
                         PutProcedureBuiltin, PutProcedureInline,
                         GetSymName,
                         ResolveImports, PutDeclared,
+                        GetProcedureDeclaredForward, PutProcedureDeclaredForward,
+                        GetProcedureDeclaredProper, PutProcedureDeclaredProper,
+                        GetProcedureDeclaredDefinition, PutProcedureDeclaredDefinition,
                         MakeError, MakeErrorS,
                         DisplayTrees ;
 
@@ -931,14 +934,20 @@ BEGIN
    ProcSym := RequestSym (tokno, name) ;
    IF IsUnknown (ProcSym)
    THEN
-      (*
-         May have been compiled in DEF or IMP module, remember that IMP maybe
-         compiled before corresponding DEF module.
-      *)
+      (* A procedure may be created in a definition or implementation module, remember
+         that an implementation module maybe compiled before the corresponding
+         definition module.
+
+         The procedure can also be created during a forward declaration.
+         We record the forward declaration as the token of creation and adjust this
+         later when we see the proper procedure declaration.  Likwwise when the forward
+         keyword is seen we assign the procedure forward token location.  *)
       ProcSym := MakeProcedure (tokno, name)
    ELSIF IsProcedure (ProcSym)
    THEN
-      (* declared in the other module, we record declaration here as well *)
+      (* Declared in the other module or it could have been declared by a forward decl,
+         we overwrite the declaration to tokno.  The forward location is assigned in
+         EndBuildForward.  *)
       PutDeclared (tokno, ProcSym)
    ELSE
       MetaError1 ('expecting a procedure name and symbol {%1Ea} has been declared as a {%1d}', ProcSym) ;
@@ -957,10 +966,20 @@ BEGIN
          PutProcedureBuiltin (ProcSym, builtin)
       END
    END ;
-   PushT (ProcSym) ;
+   PushTtok (ProcSym, tokno) ;
    StartScope (ProcSym) ;
-   IF NOT CompilingDefinitionModule ()
+   IF CompilingDefinitionModule ()
    THEN
+      IF GetProcedureDeclaredDefinition (ProcSym) = UnknownTokenNo
+      THEN
+         PutProcedureDeclaredDefinition (ProcSym, tokno)
+      ELSE
+         MetaErrorT1 (GetProcedureDeclaredDefinition (ProcSym),
+                      'first declaration of procedure {%1Ea} in the definition module', ProcSym) ;
+         MetaErrorT1 (tokno,
+                      'duplicate declaration of procedure {%1Ea} in the definition module', ProcSym)
+      END
+   ELSE
       EnterBlock (name)
    END
 END StartBuildProcedure ;
@@ -990,13 +1009,14 @@ END StartBuildProcedure ;
 
 PROCEDURE EndBuildProcedure ;
 VAR
+   tok,
    start, end: CARDINAL ;
    ProcSym   : CARDINAL ;
    NameEnd,
    NameStart : Name ;
 BEGIN
    PopTtok(NameEnd, end) ;
-   PopT(ProcSym) ;
+   PopTtok(ProcSym, tok) ;
    PopTtok(NameStart, start) ;
    IF NameEnd#NameStart
    THEN
@@ -1014,11 +1034,59 @@ BEGIN
       END
    END ;
    EndScope ;
+   IF GetProcedureDeclaredProper (ProcSym) = UnknownTokenNo
+   THEN
+      PutProcedureDeclaredProper (ProcSym, tok)
+   ELSE
+      MetaErrorT1 (GetProcedureDeclaredProper (ProcSym),
+                   'first proper declaration of procedure {%1Ea}', ProcSym) ;
+      MetaErrorT1 (tok, 'procedure {%1Ea} has already been declared', ProcSym)
+   END ;
    Assert (NOT CompilingDefinitionModule()) ;
    LeaveBlock
 END EndBuildProcedure ;
 
 
+(*
+   EndBuildForward - Ends building a forward procedure declaration.
+
+                     The Stack:
+
+                     (This procedure is not defined in definition module)
+
+                     Entry                 Exit
+
+              Ptr ->
+                     +------------+
+                     | ProcSym    |
+                     |------------|
+                     | NameStart  |
+                     |------------|
+                                           Empty
+*)
+
+PROCEDURE EndBuildForward ;
+VAR
+   ProcSym: CARDINAL ;
+   tok    : CARDINAL ;
+BEGIN
+   ProcSym := OperandT (1) ;
+   tok := OperandTok (1) ;
+   IF GetProcedureDeclaredForward (ProcSym) = UnknownTokenNo
+   THEN
+      PutProcedureDeclaredForward (ProcSym, tok)
+   ELSE
+      MetaErrorT1 (GetProcedureDeclaredForward (ProcSym),
+                   'first forward declaration of {%1Ea}', ProcSym) ;
+      MetaErrorT1 (tok, 'forward declaration of procedure {%1Ea} has already occurred', ProcSym)
+   END ;
+   PopN (2) ;
+   EndScope ;
+   Assert (NOT CompilingDefinitionModule ()) ;
+   LeaveBlock
+END EndBuildForward ;
+
+
 (*
    BuildProcedureHeading - Builds a procedure heading for the definition
                            module procedures.
diff --git a/gcc/m2/gm2-compiler/P2Build.bnf b/gcc/m2/gm2-compiler/P2Build.bnf
index d69ce2cf17e..3946f243134 100644
--- a/gcc/m2/gm2-compiler/P2Build.bnf
+++ b/gcc/m2/gm2-compiler/P2Build.bnf
@@ -97,6 +97,9 @@ FROM P2SymBuild IMPORT P2StartBuildProgramModule,
                        EndBuildProcedure,
                        BuildFunction, BuildOptFunction,
                        BuildNoReturnAttribute,
+                       BuildProcedureDefinedByForward,
+                       BuildProcedureDefinedByProper,
+                       EndBuildForward,
 
                        BuildPointerType,
                        BuildRecord, BuildFieldRecord,
@@ -115,7 +118,8 @@ FROM P2SymBuild IMPORT P2StartBuildProgramModule,
                        DetermineType, PushType, PopType,
                        SeenUnknown, SeenSet, SeenString, SeenArray, SeenConstructor,
                        SeenCast,
-                       PushRememberConstant, PopRememberConstant ;
+                       PushRememberConstant, PopRememberConstant,
+                       CheckProcedure ;
 
 FROM M2Reserved IMPORT ArrayTok, VarTok ;
 
@@ -499,6 +503,7 @@ token   'EXIT'            exittok
 token   'EXPORT'          exporttok
 token   'FINALLY'         finallytok
 token   'FOR'             fortok
+token   'FORWARD'         forwardtok
 token   'FROM'            fromtok
 token   'IF'              iftok
 token   'IMPLEMENTATION'  implementationtok
@@ -884,7 +889,9 @@ FormalTypeList := "(" ( ")" FormalReturn |
                         ProcedureParameters
                   ")" FormalReturn ) =:
 
-FormalReturn := [ ":" OptReturnType ] =:
+FormalReturn := ( ":" OptReturnType |                                      % CheckProcedure %
+                )
+              =:
 
 OptReturnType := "[" Qualident                                             % BuildOptFunction %
                                "]" | Qualident                             % BuildFunction %
@@ -1008,13 +1015,22 @@ LoopStatement := "LOOP" StatementSequence "END" =:
 
 WithStatement := "WITH" Designator "DO" StatementSequence "END" =:
 
-ProcedureDeclaration := ProcedureHeading                                   % Assert(IsProcedure(OperandT(1))) %
-                                         ";" ( ProcedureBlock
-                                                                           % Assert(IsProcedure(OperandT(1))) %
-                        Ident )
-                                                                           % EndBuildProcedure %
+ProcedureDeclaration :=                                                    % VAR top: CARDINAL ; %
+                                                                           % top := Top () %
+                        ProcedureHeading                                   % Assert(IsProcedure(OperandT(1))) %
+                                         ";" PostProcedureHeading          % Assert (top = Top ()) %
+                                                                  =:
 
-                      =:
+PostProcedureHeading := ProperProcedure | ForwardDeclaration =:
+
+ForwardDeclaration := "FORWARD"                                            % Assert (IsProcedure (OperandT (1))) %
+                                                                           % BuildProcedureDefinedByForward (OperandT (1)) %
+                                                                           % EndBuildForward %
+                    =:
+
+ProperProcedure := ProcedureBlock                                          % Assert(IsProcedure(OperandT(1))) %
+                                  Ident                                    % EndBuildProcedure %
+                                        =:
 
 DefineBuiltinProcedure :=  [ "__ATTRIBUTE__" "__BUILTIN__"
                               "(" "("                                      % PushAutoOff %
@@ -1064,6 +1080,7 @@ AttributeUnused := [ "<*"                                                  % Pus
 -- error messages
 
 ProcedureBlock :=                                                          % Assert(IsProcedure(OperandT(1))) %
+                                                                           % BuildProcedureDefinedByProper (OperandT (1)) %
                   {                                                        % Assert(IsProcedure(OperandT(1))) %
                     Declaration                                            % Assert(IsProcedure(OperandT(1))) %
                                 } [ "BEGIN" ProcedureBlockBody ] "END"     % Assert(IsProcedure(OperandT(1))) %
@@ -1161,7 +1178,7 @@ NonVarFPSection :=                                                         % VAR
                                                                            % BuildFPSection %
                 =:
 
-FormalType := "ARRAY" "OF"                                                 % VAR n: CARDINAL ; %
+FormalType := "ARRAY" "OF"                                                 % VAR n, tok: CARDINAL ; %
                                                                            % PushTF(ArrayTok, 1) %
                            { "ARRAY" "OF"                                  % PopTF(ArrayTok, n) %
                                                                            % INC(n) %
@@ -1169,9 +1186,9 @@ FormalType := "ARRAY" "OF"                                                 % VAR
                                           } Qualident
                                                       |                    % VAR Sym, Type: CARDINAL ; %
                                                         Qualident
-                                                                           % PopTF(Sym, Type) ;
+                                                                           % PopTFtok (Sym, Type, tok) ;
                                                                              PushT(NulTok) ;
-                                                                             PushTF(Sym, Type) %
+                                                                             PushTFtok (Sym, Type, tok) %
             =:
 
 ModuleDeclaration := "MODULE"                                              % M2Error.DefaultInnerModule %
diff --git a/gcc/m2/gm2-compiler/P2SymBuild.def b/gcc/m2/gm2-compiler/P2SymBuild.def
index 89a83144011..45b52f7f02d 100644
--- a/gcc/m2/gm2-compiler/P2SymBuild.def
+++ b/gcc/m2/gm2-compiler/P2SymBuild.def
@@ -30,69 +30,6 @@ DEFINITION MODULE P2SymBuild ;
    Description: pass 2 symbol creation.
 *)
 
-EXPORT QUALIFIED P2StartBuildDefModule,
-                 P2EndBuildDefModule,
-                 P2StartBuildImplementationModule,
-                 P2EndBuildImplementationModule,
-                 P2StartBuildProgramModule,
-                 P2EndBuildProgramModule,
-                 StartBuildInnerModule,
-                 EndBuildInnerModule,
-                 BuildImportOuterModule,
-                 BuildExportOuterModule,
-                 BuildImportInnerModule,
-                 BuildExportInnerModule,
-                 BlockStart, BlockEnd, BlockBegin, BlockFinally,
-                 BuildNumber,
-                 BuildString,
-                 BuildConst,
-                 BuildSubrange, BuildAligned,
-                 BuildTypeAlignment, BuildVarAlignment,
-                 P2BuildDefaultFieldAlignment, BuildPragmaConst,
-                 BuildVariable,
-                 StartBuildEnumeration,
-                 BuildType,
-                 StartBuildFormalParameters,
-                 EndBuildFormalParameters,
-                 BuildProcedureHeading,
-                 BuildFPSection,
-                 BuildVarArgs,
-                 BuildFormalVarArgs,
-                 BuildOptArg,
-                 StartBuildProcedure,
-                 EndBuildProcedure,
-                 BuildNoReturnAttribute,
-                 BuildFunction,
-                 BuildOptFunction,
-                 BuildPointerType,
-                 BuildSetType,
-                 BuildRecord,
-                 BuildFieldRecord,
-                 StartBuildVarient,
-                 EndBuildVarient,
-                 BuildVarientSelector,
-                 StartBuildVarientFieldRecord,
-                 EndBuildVarientFieldRecord,
-                 BuildNulName,
-                 BuildTypeEnd,
-                 StartBuildArray, BuildArrayComma,
-                 EndBuildArray,
-                 BuildFieldArray,
-                 BuildProcedureType,
-                 BuildFormalType,
-                 SeenCast,
-                 SeenSet,
-                 SeenArray,
-                 SeenConstructor,
-                 SeenUnknown,
-                 SeenString,
-                 SeenBoolean,
-                 SeenCType, SeenRType, SeenZType,
-                 DetermineType, PushType, PopType,
-                 PushRememberConstant,
-                 PopRememberConstant,
-                 RememberConstant ;
-
 
 (*
    BlockStart - tokno is the module/procedure/implementation/definition token
@@ -864,6 +801,13 @@ PROCEDURE StartBuildProcedure ;
 PROCEDURE EndBuildProcedure ;
 
 
+(*
+   EndBuildForward - ends building a forward procedure.
+*)
+
+PROCEDURE EndBuildForward ;
+
+
 (*
    BuildNoReturnAttribute - provide an interface to the symbol table module.
 *)
@@ -871,6 +815,39 @@ PROCEDURE EndBuildProcedure ;
 PROCEDURE BuildNoReturnAttribute (procedureSym: CARDINAL) ;
 
 
+(*
+   BuildProcedureDefinedByForward - indicates that the parameters for ProcSym have
+                                    been defined using the FORWARD keyword.
+*)
+
+PROCEDURE BuildProcedureDefinedByForward (ProcSym: CARDINAL) ;
+
+
+(*
+   BuildProcedureDefinedByProper - indicates that the parameters for ProcSym have
+                                   been defined during a proper procedure declaration.
+*)
+
+PROCEDURE BuildProcedureDefinedByProper (ProcSym: CARDINAL) ;
+
+
+(*
+   CheckProcedure - checks to see that the top of stack procedure
+                    has not been declared as a procedure function.
+
+                    The Stack:
+
+                    Entry                 Exit
+
+             Ptr ->                                      <- Ptr
+                    +------------+        +------------+
+                    | ProcSym    |        | ProcSym    |
+                    |------------|        |------------|
+*)
+
+PROCEDURE CheckProcedure ;
+
+
 (*
    BuildPointerType - builds a pointer type.
                       The Stack:
